﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using SplitDamage.Sources;

namespace SplitDamage
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            List<TextBox> lifeTextList = new List<TextBox>();
            lifeTextList.Add(Life1);
            lifeTextList.Add(Life2);
            lifeTextList.Add(Life3);
            lifeTextList.Add(Life4);
            lifeTextList.Add(Life5);

            List<TextBox> rateTextList = new List<TextBox>();
            rateTextList.Add(DefeatRate1);
            rateTextList.Add(DefeatRate2);
            rateTextList.Add(DefeatRate3);
            rateTextList.Add(DefeatRate4);
            rateTextList.Add(DefeatRate5);

            int cardCount = 0;
            List<int> lifeList = new List<int>();
            for (int i = 0; i < lifeTextList.Count; i++)
            {
                int life = int.Parse(lifeTextList[i].Text);
                if (0 < life)
                {
                    lifeList.Add(life);
                    ++cardCount;
                }
            }

            float[] defeatRates = null;
            {
                int damageCount = int.Parse(DamageCount.Text);
                double time = Math.Pow(cardCount, damageCount);
                if (10000000 > time)
                {
                    int[] cardLives = new int[cardCount];
                    for (int i = 0; i < cardCount; i++)
                    {
                        cardLives[i] = lifeList[i];
                    }
                    SplitDamageCalculator c = new SplitDamageCalculator();
                    c.CalculateP(cardLives, damageCount, out defeatRates);
                }
            }

            int cardIndex = 0;
            for (int i = 0; i < lifeTextList.Count; i++)
            {
                int life = int.Parse(lifeTextList[i].Text);
                if (0 < life)
                {
                    if (null != defeatRates)
                    {
                        rateTextList[i].Text = defeatRates[cardIndex].ToString("0.000000");
                        ++cardIndex;
                    }
                    else
                    {
                        rateTextList[i].Text = "Too many!";
                    }
                }
                else
                {
                    rateTextList[i].Text = "Not target";
                }
            }
        }
    }
}
