﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

class SplitDamageCalculator
{
    public struct CombinationProbability
    {
        public int[] combination;
        public float probability;
    }

    public void CalculateP(int[] cardLives, int damageCount, out float[] cardDefeatRates)
    {
        int numCards = cardLives.Length;
        cardDefeatRates = new float[numCards];
        CombinationProbability cp = new CombinationProbability { combination = new int[numCards], probability = 1 };
        int totalLife = 0;
        for (int j = 0; j < numCards; j++)
        {
            int life = cardLives[j];
            cp.combination[j] = life;
            totalLife += life;
        }
        if (damageCount >= totalLife)
        {
            for (int i = 0; i < numCards; i++)
            {
                cardDefeatRates[i] = 1;
            }
        }
        else if (0 < damageCount)
        {
            List<List<CombinationProbability>> layers = new List<List<CombinationProbability>>();
            for (int i = 0; i < damageCount; i++)
            {
                layers.Add(new List<CombinationProbability>());
            }
            _ListCombinationProbability(ref layers, ref cp, numCards, damageCount - 1);
            foreach (CombinationProbability resultCp in layers[0])
            {
                for (int i = 0; i < numCards; i++)
                {
                    if (0 == resultCp.combination[i])
                    {
                        cardDefeatRates[i] += resultCp.probability;
                    }
                }
            }
        }
        else
        {
            for (int i = 0; i < numCards; i++)
            {
                cardDefeatRates[i] = 0;
            }
        }
    }

    private static void _ListCombinationProbability(ref List<List<CombinationProbability>> layers, ref CombinationProbability rootCp, int numCards, int damageCount)
    {
        if (0 > damageCount)
        {
            return;
        }
        List<CombinationProbability> layer = layers[damageCount];
        for (int i = 0; i < numCards; i++)
        {
            CombinationProbability cp = new CombinationProbability() { combination = new int[numCards], probability = 0 };
            int numActiveCards = 0;
            bool isLeaf = false;
            for (int j = 0; j < numCards; j++)
            {
                int life = rootCp.combination[j];
                cp.combination[j] = life;
                if (0 == life)
                {
                    if (j == i)
                    {
                        isLeaf = true;
                        break;
                    }
                }
                else
                {
                    if (j == i)
                    {
                        cp.combination[j] = life - 1;
                    }
                    ++numActiveCards;
                }
            }
            if (!isLeaf)
            {
                cp.probability = rootCp.probability * 1 / (float)numActiveCards;
                layer.Add(cp);

                _ListCombinationProbability(ref layers, ref cp, numCards, damageCount - 1);
            }
        }
    }
}
