﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SplitDamage.Sources
{
    class SplitDamageP
    {
        public void CalcuP(int[] cardLives, int damageCount, float[] defeatRates)
        {
            bool annihilation = _IsAnnihilation(cardLives, damageCount);
            if (annihilation)
            {
                for (int i = 0; i < defeatRates.Length; i++)
                {
                    defeatRates[i] = 1;
                }
                return;
            }

            Dictionary<int, float> backNumber = new Dictionary<int, float>();
            int numCards = cardLives.Length;
            for (int i = 0; i < numCards; i++)
            {
                defeatRates[i] = 0;
                int life = cardLives[i];
                if (backNumber.ContainsKey(life))
                {
                    defeatRates[i] = backNumber[life];
                }
                else
                {
                    float p = 0;
                    if (1 == damageCount)
                    {
                        p = _CalcuOneShot(numCards, life);
                    }
                    else if (2 == damageCount)
                    {
                        p = _CalcuTwoShot(cardLives, i);
                    }
                    defeatRates[i] = p;
                    backNumber[life] = defeatRates[i];
                }
            }
        }

        private static bool _IsAnnihilation(int[] cardLives, int damageCount)
        {
            bool annihilation = false;
            int allLife = 0;
            foreach (int life in cardLives)
            {
                allLife += life;
            }
            if (damageCount >= allLife)
            {
                annihilation = true;
            }
            return annihilation;
        }

        private static float _CalcuTwoShot(int[] cardLives, int i)
        {
            int life = cardLives[i];
            if (3 > life)
            {
                if (2 == life)
                {
                    float p1 = 1 / (float)(cardLives.Length);
                    float p2 = p1;
                    return p1 * p2;
                }
                else
                {
                    float p1 = _CalcuOneShot(cardLives.Length, life);
                    float p2_1 = 1 - p1;
                    int numlife1Card = _GetNumLife1(cardLives, i);
                    float p2 = 0;
                    if (0 < cardLives.Length - 1)
                    {
                        float p2_2 = numlife1Card / (float)(cardLives.Length - 1);
                        float p2_3 = 1 - p2_2;
                        float p2_4 = _CalcuOneShot(cardLives.Length - 1, life);
                        p2 = p2_1 * (p2_3 * p1 + p2_2 * p2_4);
                    }
                    return p1 + p2;
                }
            }
            else
            {
                return 0;
            }
        }

        private static int _GetNumLife1(int[] cardLives, int idx)
        {

            int numlife1Card = 0;
            for (int i = 0; i < cardLives.Length; i++)
            {
                if (1 == cardLives[i] && i != idx)
                {
                    ++numlife1Card;
                }
            }
            return numlife1Card;
        }

        private static float _CalcuOneShot(int numCards, int life)
        {
            float p = 1;
            if (1 == life)
            {
                p = 1 / (float)numCards;
            }
            else
            {
                p = 0;
            }
            return p;
        }
    }
}
